diff --git a/src/V3Dfg.h b/src/V3Dfg.h
index c76cc8bf2a3..bab4a0498f9 100644
--- a/src/V3Dfg.h
+++ b/src/V3Dfg.h
@@ -59,8 +59,6 @@ class DfgVertex;
 class DfgGraph;
 class DfgVisitor;
 
-//------------------------------------------------------------------------------
-
 // Specialization of std::hash for a std::pair<const DfgVertex*, const DfgVertex*> for use below
 template <>
 struct std::hash<std::pair<const DfgVertex*, const DfgVertex*>> final {
@@ -72,9 +70,74 @@ struct std::hash<std::pair<const DfgVertex*, const DfgVertex*>> final {
     }
 };
 
+namespace V3Dfg {
+//-----------------------------------------------------------------------
+// Functions for compatibility tests
+
+// Returns true if the given data type can be represented in the graph
+bool isSupported(const AstNodeDType* dtypep) VL_MT_DISABLED;
+
+// Returns true if variable can be represented in the graph
+inline bool isSupported(const AstVar* varp) {
+    if (varp->isIfaceRef()) return false;  // Cannot handle interface references
+    if (varp->delayp()) return false;  // Cannot handle delayed variables
+    if (varp->isSc()) return false;  // SystemC variables are special and rare, we can ignore
+    if (varp->dfgMultidriven()) return false;  // Discovered as multidriven on earlier DFG run
+    return isSupported(varp->dtypep());
+}
+
+// Returns true if variable can be represented in the graph
+inline bool isSupported(const AstVarScope* vscp) {
+    const AstNodeModule* const modp = vscp->scopep()->modp();
+    if (VN_IS(modp, Module)) {
+        // Regular module supported
+    } else if (const AstIface* const ifacep = VN_CAST(modp, Iface)) {
+        // Interfaces supported if there are no virtual interfaces for
+        // them, otherwise they cannot be resovled statically.
+        if (ifacep->hasVirtualRef()) return false;
+    } else {
+        return false;  // Anything else (package, class, etc) not supported
+    }
+    // Check the AstVar
+    return isSupported(vscp->varp());
+}
+
+//-----------------------------------------------------------------------
+// Functions for data types
+
+// Some data types are interned, in order to facilitate type comparison
+// via pointer compariosn. These are functoins to construct the canonical
+// DFG data types
+
+// Returns data type used to represent any packed value of the given 'width'.
+inline AstNodeDType* dtypePacked(uint32_t width) {
+    return v3Global.rootp()->typeTablep()->findLogicDType(width, width, VSigning::UNSIGNED);
+}
+
+// Returns data type used to represent any array with the given type and number of elements.
+inline AstNodeDType* dtypeArray(AstNodeDType* subDtypep, uint32_t size) {
+    UASSERT_OBJ(isSupported(subDtypep), subDtypep, "Unsupported element type");
+    FileLine* const flp = subDtypep->fileline();
+    AstRange* const rangep = new AstRange{flp, static_cast<int>(size - 1), 0};
+    AstNodeDType* const dtypep = new AstUnpackArrayDType{flp, subDtypep, rangep};
+    v3Global.rootp()->typeTablep()->addTypesp(dtypep);
+    return dtypep;
+}
+
+// Return data type used to represent the type of 'nodep' when converted to a DfgVertex
+inline AstNodeDType* toDfgDType(const AstNodeDType* dtypep) {
+    dtypep = dtypep->skipRefp();
+    UASSERT_OBJ(isSupported(dtypep), dtypep, "Unsupported dtype");
+    // For simplicity, all packed types are represented with a fixed type
+    if (const AstUnpackArrayDType* const uatp = VN_CAST(dtypep, UnpackArrayDType)) {
+        return dtypeArray(toDfgDType(uatp->subDTypep()), uatp->elementsConst());
+    }
+    return dtypePacked(dtypep->width());
+}
+}  //namespace V3Dfg
+
 //------------------------------------------------------------------------------
-// Dataflow vertex type enum
-//------------------------------------------------------------------------------
+// Dataflow graph vertex type enum
 
 class VDfgType final {
 public:
@@ -93,37 +156,37 @@ inline std::ostream& operator<<(std::ostream& os, const VDfgType& t) { return os
 
 //------------------------------------------------------------------------------
 // Dataflow graph edge
-//------------------------------------------------------------------------------
-
 class DfgEdge final {
     friend class DfgVertex;
 
-    DfgEdge* m_nextp = nullptr;  // Next edge in sink list
-    DfgEdge* m_prevp = nullptr;  // Previous edge in sink list
-    DfgVertex* m_sourcep = nullptr;  // The source vertex driving this edge
-    // Note that the sink vertex owns the edge, so it is immutable, but because we want to be able
-    // to allocate these as arrays, we use a default constructor + 'init' method to set m_sinkp.
-    DfgVertex* const m_sinkp = nullptr;  // The sink vertex
+    DfgVertex* m_srcp = nullptr;  // The source vertex driving this edge - might be unconnected
+    DfgVertex* const m_dstp;  // The vertex driven by this edge, which owns this edge, so immutable
+    V3ListLinks<DfgEdge> m_links;  // V3List links in the list of sinks of m_srcp
+
+    DfgEdge() = delete;
+    VL_UNCOPYABLE(DfgEdge);
+    VL_UNMOVABLE(DfgEdge);
+
+    V3ListLinks<DfgEdge>& links() { return m_links; }
+    using List = V3List<DfgEdge, &DfgEdge::links>;
 
 public:
-    DfgEdge() {}
-    void init(DfgVertex* sinkp) { const_cast<DfgVertex*&>(m_sinkp) = sinkp; }
+    explicit DfgEdge(DfgVertex* dstp)
+        : m_dstp{dstp} {}
+    ~DfgEdge() { unlinkSrcp(); }
 
     // The source (driver) of this edge
-    DfgVertex* sourcep() const { return m_sourcep; }
+    DfgVertex* srcp() const { return m_srcp; }
     // The sink (consumer) of this edge
-    DfgVertex* sinkp() const { return m_sinkp; }
+    DfgVertex* dstp() const { return m_dstp; }
     // Remove driver of this edge
-    void unlinkSource() VL_MT_DISABLED;
+    inline void unlinkSrcp();
     // Relink this edge to be driven from the given new source vertex
-    void relinkSource(DfgVertex* newSourcep) VL_MT_DISABLED;
+    inline void relinkSrcp(DfgVertex* srcp);
 };
 
 //------------------------------------------------------------------------------
 // Dataflow graph vertex
-//------------------------------------------------------------------------------
-
-// Base data flow graph vertex
 class DfgVertex VL_NOT_FINAL {
     friend class DfgGraph;
     friend class DfgEdge;
@@ -132,10 +195,10 @@ class DfgVertex VL_NOT_FINAL {
     using UserDataStorage = void*;  // Storage allocated for user data
 
     // STATE
-    V3ListLinks<DfgVertex> m_links;  // V3List links
+    V3ListLinks<DfgVertex> m_links;  // V3List links in the DfgGraph
+    std::vector<std::unique_ptr<DfgEdge>> m_inputps;  // Input edges, as vector, for fast indexing
+    DfgEdge::List m_sinks;  // List of sink edges of this vertex
 
-protected:
-    DfgEdge* m_sinksp = nullptr;  // List of sinks of this vertex
     FileLine* const m_filelinep;  // Source location
     AstNodeDType* m_dtypep;  // Data type of the result of this vertex - mutable for efficiency
     DfgGraph* m_graphp;  // The containing DfgGraph
@@ -143,13 +206,17 @@ class DfgVertex VL_NOT_FINAL {
     uint32_t m_userCnt = 0;  // User data generation number
     UserDataStorage m_userDataStorage = nullptr;  // User data storage
 
-    // CONSTRUCTOR
-    DfgVertex(DfgGraph& dfg, VDfgType type, FileLine* flp, AstNodeDType* dtypep) VL_MT_DISABLED;
+    // METHODS
+    // Visitor accept method
+    virtual void accept(DfgVisitor& v) = 0;
 
-public:
-    virtual ~DfgVertex() VL_MT_DISABLED;
+    // Part of Vertex equality only dependent on this vertex
+    virtual bool selfEquals(const DfgVertex& that) const = 0;
 
-private:
+    // Part of Vertex hash only dependent on this vertex
+    virtual V3Hash selfHash() const = 0;
+
+    // Acessor for type List
     V3ListLinks<DfgVertex>& links() { return m_links; }
 
 public:
@@ -157,60 +224,60 @@ class DfgVertex VL_NOT_FINAL {
     template <typename Vertex>
     using List = V3List<DfgVertex, &DfgVertex::links, Vertex>;
 
-    // METHODS
-private:
-    // Visitor accept method
-    virtual void accept(DfgVisitor& v) = 0;
-
-    // Part of Vertex equality only dependent on this vertex
-    virtual bool selfEquals(const DfgVertex& that) const VL_MT_DISABLED;
+protected:
+    // CONSTRUCTOR
+    DfgVertex(DfgGraph& dfg, VDfgType type, FileLine* flp, AstNodeDType* dtypep) VL_MT_DISABLED;
+    // Use unlinkDelete instead
+    virtual ~DfgVertex() VL_MT_DISABLED = default;
 
-    // Part of Vertex hash only dependent on this vertex
-    virtual V3Hash selfHash() const VL_MT_DISABLED;
+    // Create a new input edge and return it
+    DfgEdge* newInput() {
+        m_inputps.emplace_back(new DfgEdge{this});
+        return m_inputps.back().get();
+    }
+    // Unlink all inputs and reset to no inputs
+    void resetInputs() { m_inputps.clear(); }
 
 public:
+    // Get input 'i'
+    DfgVertex* inputp(size_t i) const { return m_inputps[i]->srcp(); }
+    // Relink input 'i'
+    void inputp(size_t i, DfgVertex* vtxp) { m_inputps[i]->relinkSrcp(vtxp); }
+    // The number of inputs this vertex has. Some might be unconnected.
+    size_t nInputs() const { return m_inputps.size(); }
+
+    // The type of this vertex
+    VDfgType type() const { return m_type; }
+    // Source location
+    FileLine* fileline() const { return m_filelinep; }
     // The data type of the result of the vertex
     AstNodeDType* dtypep() const { return m_dtypep; }
-
     // Is it a packed type (instead of an array)
     bool isPacked() const { return VN_IS(dtypep(), BasicDType); }
-
-    // Source location
-    FileLine* fileline() const { return m_filelinep; }
-
-    // The type of this vertex
-    VDfgType type() const { return m_type; }
-
-    // Retrieve user data, constructing it fresh on first try.
-    template <typename T>
-    inline T& user();
-
-    // Retrieve user data, must be current.
-    template <typename T>
-    inline const T& getUser() const;
-
-    // Retrieve user data, must be current.
-    template <typename T>
-    T& getUser() {
-        return const_cast<T&>(const_cast<const DfgVertex*>(this)->getUser<T>());
-    }
-
-    // Set user data, becomes current.
-    template <typename T>
-    inline void setUser(T value);
-
     // Width of result
     uint32_t width() const {
         UASSERT_OBJ(isPacked(), this, "non-packed has no 'width()'");
         return dtypep()->width();
     }
-
     // Number of sub-elements in result vertex
     uint32_t size() const {
         if (isPacked()) return dtypep()->width();
         return VN_AS(dtypep(), UnpackArrayDType)->elementsConst();
     }
 
+    // Retrieve user data, constructing it fresh on first try.
+    template <typename T_User>
+    T_User& user();
+    // Retrieve user data, must be current.
+    template <typename T_User>
+    const T_User& getUser() const;
+    // Retrieve user data, must be current.
+    template <typename T_User>
+    T_User& getUser();
+    // Set user data, becomes current.
+    template <typename T_User>
+    void setUser(T_User value);
+
     // Cache type for 'equals' below
     using EqualsCache = std::unordered_map<std::pair<const DfgVertex*, const DfgVertex*>, uint8_t>;
 
@@ -231,20 +298,11 @@ class DfgVertex VL_NOT_FINAL {
     // Uses user data for caching hashes
     V3Hash hash() VL_MT_DISABLED;
 
-    // Source edges of this vertex
-    virtual std::pair<DfgEdge*, size_t> sourceEdges() = 0;
-
-    // Source edges of this vertex
-    virtual std::pair<const DfgEdge*, size_t> sourceEdges() const = 0;
-
-    // Arity (number of sources) of this vertex
-    size_t arity() const { return sourceEdges().second; }
-
     // Predicate: has 1 or more sinks
-    bool hasSinks() const { return m_sinksp != nullptr; }
+    bool hasSinks() const { return !m_sinks.empty(); }
 
     // Predicate: has 2 or more sinks
-    bool hasMultipleSinks() const { return m_sinksp && m_sinksp->m_nextp; }
+    bool hasMultipleSinks() const { return m_sinks.hasMultipleElements(); }
 
     // Fanout (number of sinks) of this vertex (expensive to compute)
     uint32_t fanout() const VL_MT_DISABLED;
@@ -267,69 +325,64 @@ class DfgVertex VL_NOT_FINAL {
 
     // If the node has a single sink, return it, otherwise return nullptr
     DfgVertex* singleSink() const {
-        return m_sinksp && !m_sinksp->m_nextp ? m_sinksp->m_sinkp : nullptr;
+        return m_sinks.hasSingleElement() ? m_sinks.frontp()->dstp() : nullptr;
     }
 
     // First sink of the vertex, if any, otherwise nullptr
-    DfgVertex* firtsSinkp() const { return m_sinksp ? m_sinksp->m_sinkp : nullptr; }
+    DfgVertex* firtsSinkp() { return m_sinks.empty() ? nullptr : m_sinks.frontp()->dstp(); }
 
     // Unlink from container (graph or builder), then delete this vertex
     void unlinkDelete(DfgGraph& dfg) VL_MT_DISABLED;
 
     // Relink all sinks to be driven from the given new source
-    void replaceWith(DfgVertex* newSourcep) VL_MT_DISABLED;
-
-    // Calls given function 'f' for each source vertex of this vertex
-    // Unconnected source edges are not iterated.
-    inline void forEachSource(std::function<void(DfgVertex&)> f) VL_MT_DISABLED;
-
-    // Calls given function 'f' for each source vertex of this vertex
-    // Unconnected source edges are not iterated.
-    inline void forEachSource(std::function<void(const DfgVertex&)> f) const VL_MT_DISABLED;
-
-    // Calls given function 'f' for each source edge of this vertex. Also passes source index.
-    inline void forEachSourceEdge(std::function<void(DfgEdge&, size_t)> f) VL_MT_DISABLED;
-
-    // Calls given function 'f' for each source edge of this vertex. Also passes source index.
-    inline void
-    forEachSourceEdge(std::function<void(const DfgEdge&, size_t)> f) const VL_MT_DISABLED;
-
-    // Calls given function 'f' for each sink vertex of this vertex
-    // Unlinking/deleting the given sink during iteration is safe, but not other sinks of this
-    // vertex.
-    inline void forEachSink(std::function<void(DfgVertex&)> f) VL_MT_DISABLED;
-
-    // Calls given function 'f' for each sink vertex of this vertex
-    inline void forEachSink(std::function<void(const DfgVertex&)> f) const VL_MT_DISABLED;
-
-    // Calls given function 'f' for each sink edge of this vertex.
-    // Unlinking/deleting the given sink during iteration is safe, but not other sinks of this
-    // vertex.
-    inline void forEachSinkEdge(std::function<void(DfgEdge&)> f) VL_MT_DISABLED;
-
-    // Calls given function 'f' for each sink edge of this vertex.
-    inline void forEachSinkEdge(std::function<void(const DfgEdge&)> f) const VL_MT_DISABLED;
-
-    // Returns first source edge which satisfies the given predicate 'p', or nullptr if no such
-    // sink vertex exists
-    inline const DfgEdge*
-    findSourceEdge(std::function<bool(const DfgEdge&, size_t)> p) const VL_MT_DISABLED;
-
-    // Returns first sink vertex of type 'Vertex' which satisfies the given predicate 'p',
-    // or nullptr if no such sink vertex exists
-    template <typename Vertex>
-    inline Vertex* findSink(std::function<bool(const Vertex&)> p) const VL_MT_DISABLED;
+    void replaceWith(DfgVertex* vtxp) {
+        while (!m_sinks.empty()) m_sinks.frontp()->relinkSrcp(vtxp);
+    }
+
+    // Calls given function 'f' for each source vertex of this vertex. If 'f'
+    // returns true, further sources are not iterated and this method returns
+    // true itself. Unconnected source edges are not iterated.
+    bool foreachSource(std::function<bool(DfgVertex&)> f) {
+        for (const std::unique_ptr<DfgEdge>& edgep : m_inputps) {
+            if (DfgVertex* const srcp = edgep->srcp()) {
+                if (f(*srcp)) return true;
+            }
+        }
+        return false;
+    }
 
-    // Returns first sink vertex of type 'Vertex', or nullptr if no such sink vertex exists.
-    // This is a special case of 'findSink' above with the predicate always true.
-    template <typename Vertex>
-    inline Vertex* findSink() const VL_MT_DISABLED;
+    // Calls given function 'f' for each source vertex of this vertex. If 'f'
+    // returns true, further sources are not iterated and this method returns
+    // true itself. Unconnected source edges are not iterated.
+    bool foreachSource(std::function<bool(const DfgVertex&)> f) const {
+        for (const std::unique_ptr<DfgEdge>& edgep : m_inputps) {
+            if (DfgVertex* const srcp = edgep->srcp()) {
+                if (f(*srcp)) return true;
+            }
+        }
+        return false;
+    }
 
-    // Is this a DfgConst that is all zeroes
-    inline bool isZero() const VL_MT_DISABLED;
+    // Calls given function 'f' for each sink vertex of this vertex. If 'f'
+    // returns true, further sinks are not iterated and this method returns
+    // true itself. Unlinking/deleting the given sink during iteration is safe,
+    // but not other sinks of this vertex.
+    bool foreachSink(std::function<bool(DfgVertex&)> f) {
+        for (const DfgEdge* const edgep : m_sinks.unlinkable()) {
+            if (f(*edgep->dstp())) return true;
+        }
+        return false;
+    }
 
-    // Is this a DfgConst that is all ones
-    inline bool isOnes() const VL_MT_DISABLED;
+    // Calls given function 'f' for each sink vertex of this vertex. If 'f'
+    // returns true, further sinks are not iterated and this method returns
+    // true itself.
+    bool foreachSink(std::function<bool(const DfgVertex&)> f) const {
+        for (const DfgEdge& edge : m_sinks) {
+            if (f(*edge.dstp())) return true;
+        }
+        return false;
+    }
 
     // Methods that allow DfgVertex to participate in error reporting/messaging
     void v3errorEnd(std::ostringstream& str) const VL_RELEASE(V3Error::s().m_mutex) {
@@ -387,211 +440,30 @@ class DfgVertex VL_NOT_FINAL {
     }
 
     // Human-readable vertex type as string for debugging
-    const string typeName() const { return m_type.ascii(); }
+    std::string typeName() const { return m_type.ascii(); }
 
     // Human-readable name for source operand with given index for debugging
-    virtual const string srcName(size_t idx) const = 0;
+    virtual std::string srcName(size_t idx) const = 0;
 };
 
-//------------------------------------------------------------------------------
-// Dfg vertex visitor
-//------------------------------------------------------------------------------
-
+// DfgVertex visitor
 class DfgVisitor VL_NOT_FINAL {
 public:
     // Dispatch to most specific 'visit' method on 'vtxp'
     void iterate(DfgVertex* vtxp) { vtxp->accept(*this); }
-
+    // Least specific visit method is abstract
     virtual void visit(DfgVertex* nodep) = 0;
 #include "V3Dfg__gen_visitor_decls.h"  // From ./astgen
 };
 
-//------------------------------------------------------------------------------
-// DfgVertex sub-types follow
-//------------------------------------------------------------------------------
-
-// Include macros generated by 'astgen'. These include DFGGEN_MEMBERS_<Node>
-// for each DfgVertex sub-type. The generated members include boilerplate
-// methods related to cloning, visitor dispatch, and other functionality.
-// For precise details please read the generated macros.
-#include "V3Dfg__gen_macros.h"
-
-//------------------------------------------------------------------------------
-// Implementation of dataflow graph vertices with a fixed number of sources
-//------------------------------------------------------------------------------
-
-template <size_t N_Arity>
-class DfgVertexWithArity VL_NOT_FINAL : public DfgVertex {
-    static_assert(1 <= N_Arity && N_Arity <= 4, "N_Arity must be between 1 and 4 inclusive");
-
-    std::array<DfgEdge, N_Arity> m_srcs;  // Source edges
-
-protected:
-    DfgVertexWithArity(DfgGraph& dfg, VDfgType type, FileLine* flp, AstNodeDType* dtypep)
-        : DfgVertex{dfg, type, flp, dtypep} {
-        // Initialize source edges
-        for (size_t i = 0; i < N_Arity; ++i) m_srcs[i].init(this);
-    }
-
-    ~DfgVertexWithArity() override = default;
-
-public:
-    std::pair<DfgEdge*, size_t> sourceEdges() final override {  //
-        return {m_srcs.data(), N_Arity};
-    }
-    std::pair<const DfgEdge*, size_t> sourceEdges() const final override {
-        return {m_srcs.data(), N_Arity};
-    }
-
-    template <size_t N_Index>
-    DfgEdge* sourceEdge() {
-        static_assert(N_Index < N_Arity, "Source index out of range");
-        return &m_srcs[N_Index];
-    }
-
-    template <size_t N_Index>
-    const DfgEdge* sourceEdge() const {
-        static_assert(N_Index < N_Arity, "Source index out of range");
-        return &m_srcs[N_Index];
-    }
-
-    template <size_t N_Index>
-    DfgVertex* source() const {
-        static_assert(N_Index < N_Arity, "Source index out of range");
-        return m_srcs[N_Index].sourcep();
-    }
-
-    template <size_t N_Index>
-    void relinkSource(DfgVertex* newSourcep) {
-        static_assert(N_Index < N_Arity, "Source index out of range");
-        UASSERT_OBJ(m_srcs[N_Index].sinkp() == this, this, "Inconsistent");
-        m_srcs[N_Index].relinkSource(newSourcep);
-    }
-};
-
-class DfgVertexUnary VL_NOT_FINAL : public DfgVertexWithArity<1> {
-protected:
-    DfgVertexUnary(DfgGraph& dfg, VDfgType type, FileLine* flp, AstNodeDType* dtypep)
-        : DfgVertexWithArity<1>{dfg, type, flp, dtypep} {}
-
-public:
-    ASTGEN_MEMBERS_DfgVertexUnary;
-
-    // Named getter/setter for sources
-    DfgVertex* srcp() const { return source<0>(); }
-    void srcp(DfgVertex* vtxp) { relinkSource<0>(vtxp); }
-};
-
-class DfgVertexBinary VL_NOT_FINAL : public DfgVertexWithArity<2> {
-protected:
-    DfgVertexBinary(DfgGraph& dfg, VDfgType type, FileLine* flp, AstNodeDType* dtypep)
-        : DfgVertexWithArity<2>{dfg, type, flp, dtypep} {}
-
-public:
-    ASTGEN_MEMBERS_DfgVertexBinary;
-
-    // Named getter/setter for sources
-    DfgVertex* lhsp() const { return source<0>(); }
-    void lhsp(DfgVertex* vtxp) { relinkSource<0>(vtxp); }
-    DfgVertex* rhsp() const { return source<1>(); }
-    void rhsp(DfgVertex* vtxp) { relinkSource<1>(vtxp); }
-};
-
-class DfgVertexTernary VL_NOT_FINAL : public DfgVertexWithArity<3> {
-protected:
-    DfgVertexTernary(DfgGraph& dfg, VDfgType type, FileLine* flp, AstNodeDType* dtypep)
-        : DfgVertexWithArity<3>{dfg, type, flp, dtypep} {}
-
-public:
-    ASTGEN_MEMBERS_DfgVertexTernary;
-};
-
-//------------------------------------------------------------------------------
-// Implementation of dataflow graph vertices with a variable number of sources
-//------------------------------------------------------------------------------
-
-class DfgVertexVariadic VL_NOT_FINAL : public DfgVertex {
-    DfgEdge* m_srcsp;  // The source edges
-    uint32_t m_srcCnt = 0;  // Number of sources used
-    uint32_t m_srcCap;  // Number of sources allocated
-
-    // Allocate a new source edge array
-    DfgEdge* allocSources(size_t n) {
-        DfgEdge* const srcsp = new DfgEdge[n];
-        for (size_t i = 0; i < n; ++i) srcsp[i].init(this);
-        return srcsp;
-    }
-
-    // Double the capacity of m_srcsp
-    void growSources() {
-        m_srcCap *= 2;
-        DfgEdge* const newsp = allocSources(m_srcCap);
-        for (size_t i = 0; i < m_srcCnt; ++i) {
-            DfgEdge* const oldp = m_srcsp + i;
-            // Skip over unlinked source edge
-            if (!oldp->sourcep()) continue;
-            // New edge driven from the same vertex as the old edge
-            newsp[i].relinkSource(oldp->sourcep());
-            // Unlink the old edge, it will be deleted
-            oldp->unlinkSource();
-        }
-        // Delete old source edges
-        delete[] m_srcsp;
-        // Keep hold of new source edges
-        m_srcsp = newsp;
-    }
-
-protected:
-    DfgVertexVariadic(DfgGraph& dfg, VDfgType type, FileLine* flp, AstNodeDType* dtypep,
-                      uint32_t initialCapacity)
-        : DfgVertex{dfg, type, flp, dtypep}
-        , m_srcsp{allocSources(initialCapacity)}
-        , m_srcCap{initialCapacity} {}
-
-    ~DfgVertexVariadic() override { delete[] m_srcsp; };
-
-    DfgEdge* addSource() {
-        if (m_srcCnt == m_srcCap) growSources();
-        return m_srcsp + m_srcCnt++;
-    }
-
-    void resetSources() {
-        // #ifdef VL_DEBUG TODO: DEBUG ONLY
-        for (uint32_t i = 0; i < m_srcCnt; ++i) {
-            UASSERT_OBJ(!m_srcsp[i].sourcep(), m_srcsp[i].sourcep(), "Connected source");
-        }
-        // #endif
-        m_srcCnt = 0;
-    }
-
-    void clearSources() {
-        for (uint32_t i = 0; i < m_srcCnt; ++i) {
-            UASSERT_OBJ(m_srcsp[i].sourcep(), this, "Unconnected source");
-            m_srcsp[i].unlinkSource();
-        }
-        m_srcCnt = 0;
-    }
-
-    ASTGEN_MEMBERS_DfgVertexVariadic;
-
-    DfgEdge* sourceEdge(size_t idx) const { return &m_srcsp[idx]; }
-    DfgVertex* source(size_t idx) const { return m_srcsp[idx].sourcep(); }
-
-public:
-    std::pair<DfgEdge*, size_t> sourceEdges() override { return {m_srcsp, m_srcCnt}; }
-    std::pair<const DfgEdge*, size_t> sourceEdges() const override { return {m_srcsp, m_srcCnt}; }
-};
-
 // DfgVertex subclasses
 #include "V3DfgVertices.h"
 
-// The rest of the DfgVertex subclasses are generated by 'astgen' from AstNodeExpr nodes
-#include "V3Dfg__gen_auto_classes.h"
+// Specializations of privateTypeTest
+#include "V3Dfg__gen_type_tests.h"  // From ./astgen
 
 //------------------------------------------------------------------------------
 // Dataflow graph
-//------------------------------------------------------------------------------
-
 class DfgGraph final {
     friend class DfgVertex;
 
@@ -649,10 +521,6 @@ class DfgGraph final {
 
     // METHODS
 public:
-    // Add DfgVertex to this graph (assumes not yet contained).
-    inline void addVertex(DfgVertex& vtx);
-    // Remove DfgVertex form this graph (assumes it is contained).
-    inline void removeVertex(DfgVertex& vtx);
     // Number of vertices in this graph
     size_t size() const { return m_size; }
     // Parent module - or nullptr when run after V3Scope
@@ -677,13 +545,51 @@ class DfgGraph final {
     DfgVertex::List<DfgVertex>& opVertices() { return m_opVertices; }
     const DfgVertex::List<DfgVertex>& opVertices() const { return m_opVertices; }
 
+    // Add DfgVertex to this graph (assumes not yet contained).
+    void addVertex(DfgVertex& vtx) {
+        // Note: changes here need to be replicated in DfgGraph::mergeGraphs
+        ++m_size;
+        if (DfgConst* const cVtxp = vtx.cast<DfgConst>()) {
+            m_constVertices.linkBack(cVtxp);
+        } else if (DfgVertexVar* const vVtxp = vtx.cast<DfgVertexVar>()) {
+            m_varVertices.linkBack(vVtxp);
+        } else {
+            m_opVertices.linkBack(&vtx);
+        }
+        vtx.m_userCnt = 0;
+        vtx.m_graphp = this;
+    }
+
+    // Remove DfgVertex form this graph (assumes it is contained).
+    void removeVertex(DfgVertex& vtx) {
+        // Note: changes here need to be replicated in DfgGraph::mergeGraphs
+        --m_size;
+        if (DfgConst* const cVtxp = vtx.cast<DfgConst>()) {
+            m_constVertices.unlink(cVtxp);
+        } else if (DfgVertexVar* const vVtxp = vtx.cast<DfgVertexVar>()) {
+            m_varVertices.unlink(vVtxp);
+        } else {
+            m_opVertices.unlink(&vtx);
+        }
+        vtx.m_userCnt = 0;
+        vtx.m_graphp = nullptr;
+    }
+
     // Calls given function 'f' for each vertex in the graph. It is safe to manipulate any vertices
     // in the graph, or to delete/unlink the vertex passed to 'f' during iteration. It is however
     // not safe to delete/unlink any vertex in the same graph other than the one passed to 'f'.
-    inline void forEachVertex(std::function<void(DfgVertex&)> f);
+    void forEachVertex(std::function<void(DfgVertex&)> f) {
+        for (DfgVertexVar* const vtxp : m_varVertices.unlinkable()) f(*vtxp);
+        for (DfgConst* const vtxp : m_constVertices.unlinkable()) f(*vtxp);
+        for (DfgVertex* const vtxp : m_opVertices.unlinkable()) f(*vtxp);
+    }
 
     // 'const' variant of 'forEachVertex'. No mutation allowed.
-    inline void forEachVertex(std::function<void(const DfgVertex&)> f) const;
+    void forEachVertex(std::function<void(const DfgVertex&)> f) const {
+        for (const DfgVertexVar& vtx : m_varVertices) f(vtx);
+        for (const DfgConst& vtx : m_constVertices) f(vtx);
+        for (const DfgVertex& vtx : m_opVertices) f(vtx);
+    }
 
     // Return an identical, independent copy of this graph. Vertex and edge order might differ.
     std::unique_ptr<DfgGraph> clone() const VL_MT_DISABLED;
